
//import io from 'socket.io-client';

//let io = require("socket.io");


(function(){
  //  import io from 'socket.io-client';

  var base_url = "ws://api01.xcontactcenter.com:8000";
  var config = {
    name: "Dufrio Teste",    
    username: '',
    email: '',
    protocolo: undefined,
    ClientID: '97fa117a00cfcd590f2f85109105b453',
    dados_adicionais: '',
    conectado: true
  };

  function ready(fn) {
    if (document.readyState != 'loading'){
      fn();
    } else {
      document.addEventListener('DOMContentLoaded', fn);
    }
  } 



  ready(function(){
    
    var css = document.createElement('link');   
    css.id = 'id32';
    css.rel = 'stylesheet';
    css.href = './chat.css';
    document.head.appendChild(css);
    

    var script = document.createElement('script');
    script.id = 'id1';
    script.src = 'https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/js/bootstrap.min.js';
    document.head.appendChild(script);
   
    var link1 = document.createElement('link');
    link1.id = 'id3';
    link1.rel = 'stylesheet';
    link1.href = 'https://fonts.googleapis.com/icon?family=Material+Icons';
    document.head.appendChild(link1);

    var link = document.createElement('link');
    link.id = 'id2';
    link.rel = 'stylesheet';
    link.href = 'https://stackpath.bootstrapcdn.com/bootstrap/4.3.1/css/bootstrap.min.css';
    document.head.appendChild(link);

 
   
        var div = document.createElement('div');
        div.classList.add("chat-button");
        div.innerHTML = '<svg xmlns="http://www.w3.org/2000/svg" version="1.1" x="0px" y="0px" viewBox="0 0 100 125"><g transform="translate(0,-952.36218)"><path style="color:#FFFFFF;enable-background:accumulate;" d="m 50.000002,963.36217 c -22.6486,0 -41,14.9704 -41,33.43753 0,10.7045 6.4027,19.4424 16,25.5625 l -8,19 22,-12 c 2.9907,0.5659 7.7979,0.8438 11,0.8438 22.6486,0 40.999996,-14.9392 40.999996,-33.4063 0,-18.46713 -18.351396,-33.43753 -40.999996,-33.43753 z m -23,28.00003 c 2.7614,0 5,2.2386 5,5 0,2.7614 -2.2386,5 -5,5 -2.7614,0 -5,-2.2386 -5,-5 0,-2.7614 2.2386,-5 5,-5 z m 23,0 c 2.7614,0 5,2.2386 5,5 0,2.7614 -2.2386,5 -5,5 -2.7614,0 -5,-2.2386 -5,-5 0,-2.7614 2.2386,-5 5,-5 z m 23,0 c 2.761396,0 4.999996,2.2386 4.999996,5 0,2.7614 -2.2386,5 -4.999996,5 -2.7614,0 -5,-2.2386 -5,-5 0,-2.7614 2.2386,-5 5,-5 z" fill="#fff" stroke="none" marker="none" visibility="visible" display="inline" overflow="visible"/></g></svg>';
        div.addEventListener('click', function(){
          showAuthForm();
          //showChatWidget();  
         
        });
        document.body.appendChild(div);
        if(localStorage.getItem("protocolo")) {   
         
                     
          if(localStorage.getItem('username')){
            conectarSocket()
            config.username = localStorage.getItem('username'); 
          }
        }  
    window.addEventListener("beforeunload", function(evt){
     
    });
  });
  function addMessageToHistory(type, text, id) {
    var history = JSON.parse(localStorage.getItem("chat-history"));
    if(!history) {
      history = [];
    }
    if(history.length > 5) {
      history.shift();
    }
    history.push({
      type: type,
      text: text,
      messageID:id
    });
    localStorage.setItem("chat-history", JSON.stringify(history));
    return history;
  }
  function hideChatButton() {
    document.querySelector('.chat-button').classList.add("hidden");
  }

  function showChatButton() {
    document.querySelector('.chat-button').classList.remove("hidden");
  }

  function hideChatWidget() {    
    //document.querySelector('.chat-widget').classList.add("hidden");
    document.querySelector('.chat-widget').remove();
    

  }

  function showAuthForm(){
    
    var div = document.createElement('div');
    div.classList.add("chat-widget1");

    div.innerHTML = 
                    '<div class="container" style="background-color:#007bff;">'+                   
                       '<h4 class="text-center" style="color:#fff; !important"> Atendimento via Chat </h4>' +                      
                    '</div>' +
                    '<form id="authForm">'+
                    '<div class="mt-4 form-group">' +
                      '<div class="col-sm-12" id="div_tipo">' +
                        '<label for="tipo_contato"> Tipo de Contato:</label>' +
                        '<select id="tipo_contato" class="form-control" placeholder="Selecione"><option>Selecione</option><option value="somar">Somar</option><option value="SAC">SAC</option></select>' +
                      '</div>' +
                      '<div id="div_nome" class="col-sm-12  >' +
                      '<label for="username"> Nome:</label>' +
                      '<label></label>'+
                        '<input type="text" class="form-control" name="nome" id="username" />' +
                      '</div>' +
                      '<div class="mt-2 col-sm-12" id="div_email">' +
                        '<label for="email"> Email:</label>' +
                        '<input type="email" name="email" class="form-control" id="email" placeholder="Exemplo:usuario@email.com" />' +
                      '</div>' +
                      '<div class="col-sm-12" id="div_cpf">' +
                        '<label for="cpf_cnpj"> CPF</label>' +
                        '<input type="text" name="cpf_cnpj" class="form-control"  maxlength="12" id="cpf_cnpj" />' +
                      '</div>' +
                      '<div class="col-sm-12" id="div_estado">' +
                        '<label for="estado">Estado</label>' +
                        '<select id="estado" name="estado" class="form-control" placeholder="Selecione"><option>Selecione</option> <option value="AC">Acre</option>'+
                        '<option value="AL">Alagoas</option>'+
                        '<option value="AP">Amapá</option>'+
                        '<option value="AM">Amazonas</option>'+
                        '<option value="BA">Bahia</option>'+
                        '<option value="CE">Ceará</option>'+
                        '<option value="DF">Distrito Federal</option>'+
                        '<option value="ES">Espírito Santo</option>'+
                        '<option value="GO">Goiás</option>'+
                        '<option value="MA">Maranhão</option>'+
                        '<option value="MT">Mato Grosso</option>'+
                        '<option value="MS">Mato Grosso do Sul</option>'+
                        '<option value="MG">Minas Gerais</option>'+
                        '<option value="PA">Pará</option>'+
                        '<option value="PB">Paraíba</option>'+
                        '<option value="PR">Paraná</option>'+
                        '<option value="PE">Pernambuco</option>'+
                        '<option value="PI">Piauí</option>'+
                        '<option value="RJ">Rio de Janeiro</option>'+
                        '<option value="RN">Rio Grande do Norte</option>'+
                        '<option value="RS">Rio Grande do Sul</option>'+
                        '<option value="RO">Rondônia</option>'+
                        '<option value="RR">Roraima</option>'+
                        '<option value="SC">Santa Catarina</option>'+
                        '<option value="SP">São Paulo</option>'+
                        '<option value="SE">Sergipe</option>'+
                        '<option value="TO">Tocantins</option></select>' +
                      '</div>' +   
                      '<div class="col-sm-12" id="div_fone">' +
                        '<label for="fone"> Telefone:</label>' +
                        '<input type="text" name="fone" class="form-control" maxlength="15" id="telefone" />' +
                      '</div>' +                       
                      
                     '<div class="container row">'+   
                     '<div class="col-sm-6 mt-4">'+
                          '<img src="./logo.png" style="width:70%; margin-top:30px !important;">' +     
                     '</div>'+                             
                      '<div class="col-sm-6 mt-4">' +
                        '<button type="button" id="btn_cad"  title="Prosseguir para chat" class="float-right mt-2 btn btn-lg btn-primary"  >Entrar</button>' +                       
                      '</div>' +  
                     '</div>'+
                    '</div>'+                    
                    '</form>';

    document.body.appendChild(div);
    var dados_adicionais;
    id('telefone').onkeypress = function(){
      console.log(mtel);
      mascara( this, mtel );
    }

    id('cpf_cnpj').onkeypress = function(){
      console.log(mCpf);
      mascara( this, mCpf );
    }
 
    document.getElementById("btn_cad").onclick = function(evt){
      if(document.getElementById("username").value != '' && 
          document.getElementById("email").value != '' && 
          document.getElementById("estado").value != '' && 
          document.getElementById("cpf_cnpj").value != '' &&
          document.getElementById("tipo_contato").value != '' &&
          document.getElementById("telefone").value != '' && TestaCPF(document.getElementById("cpf_cnpj").value))
      {
          config.username = document.getElementById("username").value;
          localStorage.setItem('username', config.username);   
          config.email = document.getElementById("email").value;
         
          dados_adicionais = {
            nome : document.getElementById("username").value,
            email: document.getElementById("email").value,
            estado: document.getElementById("estado").value,
            cpf_cnpj: document.getElementById("cpf_cnpj").value,
            queue: document.getElementById("tipo_contato").value,
            fone: document.getElementById("telefone").value
    
          };
    
          localStorage.setItem('dados_adicionais',JSON.stringify(dados_adicionais));
          config.dados_adicionais = dados_adicionais;
          console.log('DADOS_ADICIONAIS', dados_adicionais);
          console.log(config);
    
          if(config.username !== '' && config.email !== ''){
           conectarSocket()
          }
        
       
     
    

    }else{  

      if(document.getElementById("cpf_cnpj").value == ''){
        invalidForm('O campo cpf é obrigatório', 'div_cpf', 'cpf_cnpj');
      }else if (!TestaCPF(document.getElementById("cpf_cnpj").value)){
        invalidForm('cpf invalido', 'div_cpf', 'cpf_cnpj');
      }else{
        validForm('cpf_cnpj');
      }
      
      if(document.getElementById("tipo_contato").value == 'Selecione'){      
        invalidForm('Favor selecione um tipo de contato', 'div_tipo', 'tipo_contato');
      }else{
        validForm('tipo_contato');
      }
      if(document.getElementById("username").value == ''){
        invalidForm('O campo nome é obrigatório','div_nome','username');
      }else{
        validForm('username');
      }
      if(document.getElementById("email").value == ''){
        invalidForm('O campo email é obrigatório', 'div_email', 'email');
      }else{
        validForm('email');
      }
     
      if(document.getElementById("estado").value == 'Selecione'){
        invalidForm('Favor selecione seu estado', 'div_estado', 'estado');
      }else{
        validForm('estado');
      }

      if(document.getElementById("telefone").value == ''){
        invalidForm('O campo telefone é obrigatório', 'div_fone', 'telefone');
      }else{
        validForm('telefone');
      }

   

      

      // alert('Favor, preencher todos os campos');
    }
      
    }
  }
  function invalidForm (text,div_id,campo){
    document.querySelector('.chat-widget1').style.height = '700px';
    var div = document.getElementById(div_id);
    var input = document.getElementById(campo);
    //alert('CPF INVALIDO');
    if(div.children.length <= 2){      
      var div_child = document.createElement("div");   
      div_child.classList.add("invalid-feedback");
      div_child.innerHTML=text;
      div_child.style.display = 'block';
      div.appendChild(div_child);
      input.classList.add('invalid');
    } 

   

    
   
  }

  function validForm(campo){
 
    if(document.querySelector(".invalid-feedback")){
      document.querySelector(".invalid-feedback").remove();
      var input = document.getElementById(campo);
      input.classList.remove('invalid');
    }
       
  }
   
  function showChatWidget(socket) {
    if( document.querySelector('.chat-widget1')){
      document.querySelector('.chat-widget1').remove();
    }
    
    var div = document.createElement('div');
    div.classList.add("chat-widget");
    div.innerHTML = '' +
      '<div class="chat-widget-header"  style="background-color:#007bff; color:#fff !important;">' +
         '<span class="left">' +        
          '<span id="status" class="chat-widget-online-status"style="color:#fff !important;"></span> ' +
         localStorage.getItem('admin_name') +
        '</span>' +        
        '<span class="right">' +
          '<a href="#" class="close">&times;</a>' +
        '</span>' +
      '</div></div>' +
      '<div class="chat-widget-messages"' +
        '<ul id="ul-chat" style="text-decoration:none;"></ul>' +
      '</div>' +
      '<div class="chat-widget-input">' +
        '<div class="container">'+
        '<div class="row mb-4">'+
        '<div class="col-10">'+
        '<textarea id="text" name="chat-widget-message" placeholder=" Digite aqui..."></textarea>' +
        '</div>'+
        '<div class="col-2">'+
       '<i id="envia" class="material-icons">send</i>'+
        '</div>'+
        '</div>'+
      '</div>'
      ;
    document.body.appendChild(div);
    document.querySelector("#envia").addEventListener("click", function(){      
      sendCurrentMessage(socket);
    })
    document.querySelector(".chat-widget-input textarea").addEventListener("keydown", function(evt){
      if(evt.keyCode == 13) {
        sendCurrentMessage(socket);
        evt.preventDefault();
      }
    });
    document.querySelector(".chat-widget-input textarea").focus();

    document.querySelector(".chat-widget .close").addEventListener("click", function(evt){
      evt.preventDefault();
      closeChatWidget();
    });
  }

  
  function showChatWidget2(socket) {
  var div = document.createElement('div');
  div.classList.add("chat-widget2");
  div.innerHTML = '' +
    '<div class="chat-widget-header"  style="background-color:#007bff; color:#fff !important;">' +
       '<span class="left">' +        
        '<span id="chat-widget-online-status"style="color:#fff !important;" class="online"></span> ' +
        config.name +
      '</span>' +        
      '<span class="right">' +
        '<a href="#" class="close">&times;</a>' +
      '</span>' +
    '</div></div>' +
    '<div class="chat-widget-messages"' +
      '<ul id="ul-chat" style="text-decoration:none;"></ul>' +
    '</div>' +
    '<div class="chat-widget-input">' +
      '<div class="container">'+
      '<div class="row">'+
      '<div class="col-10">'+
      '<textarea name="chat-widget-message" placeholder=" Digite aqui..."></textarea>' +
      '</div>'+
      '<div class="col-2">'+
     '<i id="envia" class="fas fa-arrow-right"></i>'+
      '</div>'+
      '</div>'+
    '</div>'
    ;
  document.body.appendChild(div);
  document.querySelector("#envia").addEventListener("click", function(){      
    sendCurrentMessage(socket);
  })
  document.querySelector(".chat-widget-input textarea").addEventListener("keydown", function(evt){
    if(evt.keyCode == 13) {
      sendCurrentMessage(socket);
      evt.preventDefault();
    }
  });
  document.querySelector(".chat-widget-input textarea").focus();

  document.querySelector(".chat-widget2 .close").addEventListener("click", function(evt){
    evt.preventDefault();
    closeChatWidget();
  });

  //Request a chat session token or use the one that already exists   
  
  //document.querySelector(".chat-widget-input textarea").disabled = false;
}

  function mascara(o,f){
    v_obj=o
    v_fun=f
    setTimeout(() => {
      execmascara()
    }, 1);
}
function execmascara(){
    v_obj.value=v_fun(v_obj.value)
}
function mCpf(v){
    v=v.replace(/(\.|\/|\-)/g,"");          //Remove tudo o que não é dígito
    v=v.replace(/(\d{3})(\d{3})(\d{3})(\d{2})/g,"\$1.\$2.\$3\-\$4");    
    return v;
}
function mtel(v){
  v=v.replace(/\D/g,"");             //Remove tudo o que não é dígito
  v=v.replace(/^(\d{2})(\d)/g,"($1) $2"); //Coloca parênteses em volta dos dois primeiros dígitos
  v=v.replace(/(\d)(\d{4})$/,"$1-$2");    //Coloca hífen entre o quarto e o quinto dígitos
  return v;
}
function id( el ){
	return document.getElementById( el );
}
// window.onload = function(){
// 	id('telefone').onkeyup = function(){
// 		mascara( this, mtel );
// 	}
// }


  function closeChatWidget() {  
    //alert('alo');
    localStorage.removeItem("chat-history");
    localStorage.removeItem("protocolo");
    localStorage.removeItem("username");
    localStorage.removeItem("admin_name");
    localStorage.removeItem("dados_adicionais");
    config.conectado = false;
    window.location.reload();
    hideChatWidget();
    showChatButton();
  }
  
  function sendCurrentMessage(socket) {
      var protocolo = localStorage.getItem('protocolo');
      var input = document.querySelector(".chat-widget-input textarea");
      var text = input.value;
      input.value = "";
      aux = [];
      addMessageToHistory('me',text, 0);
      if(text != ''){
      var li = appendMyMessage(text);
      aux.push({
        Msg: text,
        fromID:socket.id,
        socketID:socket.id,
        messageID:0,
        ClientID:  config.ClientID,
        toID: '4s8VnQ-ZH23DFsAJAAAF',
        nome: localStorage.getItem('username'),
        action: 'webChatMessage',
        protocolo: protocolo,
        data_hora: new Date(),
        dados_adicionais: JSON.parse(localStorage.getItem('dados_adicionais')),
        queue:JSON.parse(localStorage.getItem('dados_adicionais')).queue
      })
      console.log(aux);  
      socket.emit('message',  JSON.stringify(aux[0]));          
    }
  }

  
  function loadMessageHistory() {
	console.log('loadMessageHistory');
    var history = JSON.parse(localStorage.getItem("chat-history"));
    if(history) {
      var li;
      for(var i in history) {
        var msg = history[i];
        if(msg.type == "me") {
          li = appendMyMessage(msg.text, false);
          //li.classList.remove("pending");
        } else {
          li = appendRemoteMessage(null, msg.text, false);
        }
      }
      
      li.scrollIntoView();
    }
  }


 
  function appendMyMessage(text, scroll=true) {
    var li = document.createElement("li");   
    li.classList.add("bubble","me");
      var div = document.createElement("div");
        var span = document.createElement("span");
        var p = document.createElement("p");
        p.innerText = text;
        span.appendChild(p);        
        div.appendChild(span);
        li.appendChild(div);
    
    console.log(li);
    document.querySelector("#ul-chat").appendChild(li);
    if(scroll) {
      // TODO: scrolls the rest of the page too in safari!
      li.scrollIntoView();
    }
    return li;
  }

  function appendRemoteMessage(username, text, scroll=true) {
    var li = document.createElement("li");
    li.classList.add("bubble", "you");
      var div = document.createElement("div");
        var span = document.createElement("span");
        //text = autolink(escapeHTML(text));
        span.innerHTML = text;
      div.appendChild(span);
    li.appendChild(div);
    
    document.querySelector("#ul-chat").appendChild(li);
    if(scroll) {
      // TODO: scrolls the rest of the page too in safari!
      li.scrollIntoView();
    }
    return li;
  }

  function conectarSocket(){  
    const socket = io(base_url);    
      var id = '';
    
     var dados_adicionais = JSON.parse(localStorage.getItem('dados_adicionais'));
     socket.on('connect', () => {
       var prt= localStorage.getItem('protocolo');
      
       socket.emit('authentication', JSON.stringify({xcontactID:config.ClientID, id:socket.id, nome:config.username, token: "teste",ativo:1, protocolo:prt, queue:dados_adicionais.queue, action:"webChat"}));
       // rl.prompt();
       //id = socket.id;
       config.conectado = true;
     });
     if(!config.conectado){
       alert('aqui');
       socket.close();     
     }
    
     socket.on('authenticated', () => {
       console.log('Bem vindo ao Xcontact CLI, use help para mais informações.');      
     });

     socket.on('message', (data)=>{
       console.log(data);
     //  if(data[0].fromID !== socket.id && data[0].id === socket.id){
         var dados = JSON.parse(data);
       
         console.log(dados.nome);      
         if(dados.action == 'ClientChatMessage'){
           addMessageToHistory('you',dados.message,dados.messageID);
           var msg = JSON.parse(localStorage.getItem('chat-history'));
               var aux = false; 
               for(let i = 0; i < msg.length; i++){
                 if(dados.messageID == msg.messageID){
                   aux = true;
                 }
               }
               if(!aux){
                 appendRemoteMessage(dados.nome, dados.message);
               }         
         }
         if(dados.event == 'QueueDisponivel'){  
          localStorage.setItem('admin_name', dados.nome);
          config.username =dados.nome                  
           localStorage.setItem('protocolo',dados.protocolo);
         
           console.log(document.querySelector(".chat-widget"))
           if(dados.queue == dados_adicionais.queue){
             if(document.querySelector('.chat-widget') == null){
              showChatWidget(socket) 
              document.querySelector(".chat-widget-input").disabled = false;
              console.log(dados.resposta);
              var resposta = dados.resposta;
              resposta = resposta.replace("$protocolo",dados.protocolo);
              console.log(resposta); 
              appendServerMessage('server',resposta,true); 
              loadMessageHistory()                
             }
             document.getElementById("status").classList.add("chat-widget-online-status");
             document.getElementById("status").classList.remove("chat-widget-offline-status");
             document.querySelector("#text").disabled = false;
           }
         }
         
         if(dados.event == 'QueueIndisponivel'){
              if(document.querySelector('#text') == null){
               
                showChatWidget(socket)             
                console.log(dados.resposta);
                config.username =dados.nome         
                var resposta = dados.resposta;
              // resposta = resposta.replace("$protocolo",dados.protocolo);
                console.log(resposta);                
                appendServerMessage('danger',resposta,true);                
                loadMessageHistory()
              }
              document.getElementById("status").classList.remove("chat-widget-online-status");
              document.getElementById("status").classList.add("chat-widget-offline-status");
              document.querySelector("#text").disabled = true;
         }

         if(dados.event == 'QueueSemAgentes'){
            var resposta = dados.resposta;    
            if(document.querySelector('#text') == null){          
              showChatWidget(socket)             
              console.log(dados.resposta);
              var resposta = dados.resposta;       
              console.log(resposta);
              loadMessageHistory()    
              appendServerMessage('danger',resposta,true);  
              document.getElementById("status").classList.remove("chat-widget-online-status");
              document.getElementById("status").classList.add("chat-widget-offline-status");
            }else{
              document.getElementById("status").classList.remove("chat-widget-online-status");
              document.getElementById("status").classList.add("chat-widget-offline-status");
              appendServerMessage('danger',resposta,true);  
            }

         }
          
     })

  }

  function appendServerMessage(classe, text, scroll=true) {
    var li = document.createElement("li");
    li.classList.add("bubble", classe);
    var div = document.createElement("div");
    var span = document.createElement("span");
    span.innerHTML = text;
    div.appendChild(span);
    li.appendChild(div);
    document.querySelector("#ul-chat").appendChild(li);
    if(scroll) {
      // TODO: scrolls the rest of the page too in safari!
      li.scrollIntoView();
    }
    return li;
  }

 
function TestaCPF(cpf) {
  cpf = cpf.replace(/[^\d]+/g,'');	
	if(cpf == '') return false;	
	// Elimina CPFs invalidos conhecidos	
	if (cpf.length != 11 || 
		cpf == "00000000000" || 
		cpf == "11111111111" || 
		cpf == "22222222222" || 
		cpf == "33333333333" || 
		cpf == "44444444444" || 
		cpf == "55555555555" || 
		cpf == "66666666666" || 
		cpf == "77777777777" || 
		cpf == "88888888888" || 
		cpf == "99999999999")
			return false;		
	// Valida 1o digito	
	add = 0;	
	for (i=0; i < 9; i ++)		
		add += parseInt(cpf.charAt(i)) * (10 - i);	
		rev = 11 - (add % 11);	
		if (rev == 10 || rev == 11)		
			rev = 0;	
		if (rev != parseInt(cpf.charAt(9)))		
			return false;		
	// Valida 2o digito	
	add = 0;	
	for (i = 0; i < 10; i ++)		
		add += parseInt(cpf.charAt(i)) * (11 - i);	
	rev = 11 - (add % 11);	
	if (rev == 10 || rev == 11)	
		rev = 0;	
	if (rev != parseInt(cpf.charAt(10)))
		return false;		
	return true;   
}


})();



